package com.jz.manage.moduls.controller.file;

import com.jz.common.utils.Result;
import com.jz.manage.moduls.service.PictureService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.net.ftp.FTPReply;
import org.apache.tomcat.util.http.fileupload.IOUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import sun.misc.BASE64Encoder;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;

/** * @ClassName:
 * @Author: Carl
 * @Date: 2021/1/12
 * @Version:
 */
@RestController
@Api(tags = "图片处理")
public class PictureController {

    @Autowired
    private PictureService pictureService;

    @PostMapping("/uploadPicture")
    @ApiOperation(value = "图片上传")
    @ResponseBody
    public Result uploadPicture(MultipartFile file) {
//		Map<String, Object> paramer = dataGoodsService.uploadPicture(file);
        Result result = pictureService.uploadPicture(file);
        return result;
    }

	@GetMapping("/downloadPicture")
	@ApiOperation(value = "图片下载")
	public Result downloadPicture(@RequestParam(name = "url") String url, HttpServletResponse response) {

        String host = "192.168.1.141";
        int port = 21;
        String username ="ftpuser";
        String password = "9zDatacn";
        FTPClient ftp = new FTPClient();
        String remotePath = url.substring(0, url.lastIndexOf("/")+1);
        String ftpUrl = url.substring(url.lastIndexOf("/") +1);
        try {
            int reply;
            ftp.connect(host, port);
            // 登录
            ftp.login(username, password);
            reply = ftp.getReplyCode();
            if (!FTPReply.isPositiveCompletion(reply)) {
                ftp.disconnect();
            }
            ftp.enterLocalPassiveMode();
            // 到FTP服务器目录
            ftp.changeWorkingDirectory("/2021/1/12/");
            InputStream in = ftp.retrieveFileStream(ftpUrl);
            ServletOutputStream outputStream = response.getOutputStream();
            int len = 0;
            byte[] buffer = new byte[1024];
            while ((len = in.read(buffer)) != -1) {
                outputStream.write(buffer, 0, len);
            }
//            byte[] bytes = sos.toByteArray();
            response.setHeader("Content-Disposition", "attachment;filename="+".jpg");
            IOUtils.copy(in, outputStream);
            in.close();
            outputStream.close();
            ftp.logout();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (ftp.isConnected()) {
                try {
                    ftp.disconnect();
                } catch (Exception ioe) {
                }
            }
        }
        Result result = new Result();


        return result;
	}
}
