package com.jz.manage.moduls.service.impl;

import com.jz.common.utils.FtpUtil;
import com.jz.common.utils.RandomUtil;
import com.jz.common.utils.Result;
import com.jz.common.utils.StatusCode;
import com.jz.manage.moduls.service.PictureService;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;

/**
 * @ClassName:
 * @Author: Carl
 * @Date: 2021/1/12
 * @Version:
 */
@Service("pictureService")
public class PictureServiceImpl implements PictureService {
    /**
     * 图片上传
     *
     * @param file
     * @return
     */
    @Override
    public Result uploadPicture(MultipartFile file) {
        Result result = new Result();
        if (file.getSize() > 10240000) {
            return Result.of_error("图片格式太大，不能超过10MB!");
        }
        // 获取图片名称
        String originalFilename = file.getOriginalFilename();
        // 获取图片扩展名
        String extensionName = originalFilename.substring(originalFilename.lastIndexOf("."));
        // 重新命名图片
        String picture = RandomUtil.getStringRandom(16) + extensionName;
        // 上传图片
        try {
            boolean flag = FtpUtil.uploadFile("192.168.1.141", 21, "ftpuser", "9zDatacn", "/", "/2021/1/12", picture, file.getInputStream());
            if (flag) {
                String url = "/manage/downloadPicture" + "/2021/1/12" + "/" + picture;
                result.setData(url);
                result.setMsg("图片上传成功!");
            }else {
                result.setMsg("图片上传失败!");
                result.setCode(StatusCode.ERROR);
            }
        } catch (IOException e) {
            e.printStackTrace();
            result.setMsg("图片上传失败!");
            result.setCode(StatusCode.ERROR);
        }
        return result;
    }

    /**
     * 图片下载
     *
     * @param url
     * @return
     */
    @Override
    public Result downloadPicture(String url) {
        String ftpUrl = url.substring(url.lastIndexOf("/") +1);
        Result result = new Result();
        try{
            boolean flag = FtpUtil.downloadFile("192.168.1.141", 21, "ftpuser", "9zDatacn", "/2021/1/12/", ftpUrl, "");
            if (flag) {
                result.setMsg("下载成功!");
            }else {
                result.setMsg("下载失败!");
            }
        }catch (Exception e) {
            e.printStackTrace();
            result.setMsg("下载失败!");
            result.setCode(StatusCode.ERROR);
        }
        return result;
    }
}
